#!/usr/bin/python
# -*- coding: utf-8 -*-
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

from dlgBase import DlgBase

import os
import gtk

class DlgTerm(DlgBase) :

    #  === Constructor ===
    def __init__(self, parent) :
        DlgBase.__init__(self, parent, 'dlg-term', ['txtOutput', 'btnClose'])

    # === Display the dialog box and execute the given command line ===
    def show(self, cmdLine) :
        # Prepare the buffer
        txtBuffer = self.txtOutput.get_buffer()
        self.txtOutput.grab_focus()
        txtBuffer.set_text('')
        self.btnClose.set_sensitive(False)
        self.dialog.show()
        # Execute the command and display its output
        cmd = os.popen(cmdLine)
        while True :
            # Don't block the GUI
            while gtk.events_pending():
                gtk.main_iteration()
            # Display output lines one by one
            output = cmd.readline()
            if not output:
                break
            txtBuffer.insert(txtBuffer.get_end_iter(), output)
            # Scroll to the end
            self.txtOutput.scroll_mark_onscreen(txtBuffer.get_insert())
        # The execution of the command is done, so the 'Close' button may be used now
        cmd.close()
        self.btnClose.set_sensitive(True)

# === This object is a singleton
dlg = None
def getInstance(parent) :
    global dlg
    if dlg == None :
        dlg = DlgTerm(parent)
    return dlg
